.TH getnonfreefonts 1 "January 2007" "TeXLive" "TeXLive"
.SH NAME
getnonfreefonts \- download and install fonts which cannot be
distributed on a CD
.LP
getnonfreefonts-sys \- download and install fonts system\-wide which
cannot be distributed on a CD

.SH SYNOPSIS

.BI "getnonfreefonts [" options "] [" fontlist ]
.sp
.BI "getnonfreefonts-sys [" options "] [" fontlist ]

.SH DESCRIPTION
Some font suppliers provided fonts which can be used freely but they
disallow that money is charged for the distribution.  Hence, for
distributions on CD or DVD it is usually impossible to include
these fonts.

.B "getnonfreefonts"
is a script which downloads and installs these fonts.  Actually, it
first downloads the program
.BI "getfont"<year>
from tug.org which is then executed.
.BI "getfont"<year>
does the real work.  It will be updated occasionally to support more
fonts.  
.I <year>
denotes the TeXLive release.

.B getnonfreefonts
and
.B getnonfreefonts-sys
are identical except that
.B getnonfreefonts
installs files to $TEXMFHOME
while
.B getnonfreefonts-sys
installs files to $TEXMFLOCAL.

.BI "getfont"<year>
will not be installed permanently on your system.  It only
exists in a temporary directory while 
.BI getnonfreefonts
is running.

Run
.B getnonfreefonts --lsfonts
to get a list of supported fonts.

.SH OPTIONS

.TP
.BR "-a" , " --all"
.rg
Install all fonts.

.TP
.BR "-d" , " --debug"
.rg
Provide additional messages for debugging.  These messages are sent to
STDERR.

.TP
.BR "-f" , " --force"
.rg
Install fonts even if they are installed already.

.TP
.BR "-h" , " --help"
.rg
Print a help message.  Nothing is installed but the directories where
the fonts will be installed and the temporary directory are shown.
.BI "<" PID ">" 
will be replaced by the process ID of the current
process. 

.TP
.BR "-l" , " --lsfonts"
.rg
List all available fonts and tell whether they are installed already. 

.TP
.B --sys
.rg
If you call
.B getnonfreefonts
with the
.B --sys
option it behaves exactly like
.BR "getnonfreefonts-sys".

.TP
.BR "-v" , " --verbose"
.rg
Be more verbose.  This option is only needed for debugging.

.TP
.BR "--version"
.rg
Print version number.

.SH ENVIRONMENT
One of the environment variables
.BR "TMP" , " TEMP" ,
or 
.B  TMPDIR 
must exist.  They are used to determine where to put the temporary
files.  The directory must exist and must be writable.
.B /tmp
will be used if none of the variables is defined.

.SH REQUIREMENTS
Though this program is supposed to be used with 
.B TeX Live
it might work with other TeX distributions too.  The programs
.BR "wget"
or 
.BR "curl" ,
.BR "unzip" , 
and
.B kpsewhich
have to be installed and a recent version of
.B updmap 
is required which supports the 
.B --enable
option.

.SH BUGS
Please send bug reports to Reinhard Kotucha <reinhard.kotucha@web.de>.
